package org.antlr.analysis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.antlr.misc.IntSet;
import org.antlr.misc.IntervalSet;
import org.antlr.tool.Grammar;

public class LookaheadSet {
  public IntervalSet tokenTypeSet;
  
  public LookaheadSet() {
    this.tokenTypeSet = new IntervalSet();
  }
  
  public LookaheadSet(IntSet s) {
    this();
    this.tokenTypeSet.addAll(s);
  }
  
  public LookaheadSet(int atom) {
    this.tokenTypeSet = IntervalSet.of(atom);
  }
  
  public LookaheadSet(org.antlr.analysis.LookaheadSet other) {
    this();
    this.tokenTypeSet.addAll(other.tokenTypeSet);
  }
  
  public void orInPlace(org.antlr.analysis.LookaheadSet other) {
    this.tokenTypeSet.addAll(other.tokenTypeSet);
  }
  
  public org.antlr.analysis.LookaheadSet or(org.antlr.analysis.LookaheadSet other) {
    return new org.antlr.analysis.LookaheadSet(this.tokenTypeSet.or(other.tokenTypeSet));
  }
  
  public org.antlr.analysis.LookaheadSet subtract(org.antlr.analysis.LookaheadSet other) {
    return new org.antlr.analysis.LookaheadSet(this.tokenTypeSet.subtract(other.tokenTypeSet));
  }
  
  public boolean member(int a) {
    return this.tokenTypeSet.member(a);
  }
  
  public org.antlr.analysis.LookaheadSet intersection(org.antlr.analysis.LookaheadSet s) {
    IntSet i = this.tokenTypeSet.and(s.tokenTypeSet);
    org.antlr.analysis.LookaheadSet intersection = new org.antlr.analysis.LookaheadSet(i);
    return intersection;
  }
  
  public boolean isNil() {
    return this.tokenTypeSet.isNil();
  }
  
  public void remove(int a) {
    this.tokenTypeSet = this.tokenTypeSet.subtract(IntervalSet.of(a));
  }
  
  public int hashCode() {
    return this.tokenTypeSet.hashCode();
  }
  
  public boolean equals(Object other) {
    return this.tokenTypeSet.equals(((org.antlr.analysis.LookaheadSet)other).tokenTypeSet);
  }
  
  public String toString(Grammar g) {
    if (this.tokenTypeSet == null)
      return ""; 
    String r = this.tokenTypeSet.toString(g);
    return r;
  }
  
  public String toString() {
    return toString(null);
  }
}
